// Generated by CoffeeScript 1.3.1
var HTML, URL;

HTML = require("jsdom").dom.level3.html;

URL = require("url");

/*
HTML.HTMLElement.prototype.__defineGetter__ "offsetLeft",   -> 0
HTML.HTMLElement.prototype.__defineGetter__ "offsetTop",    -> 0
HTML.HTMLElement.prototype.__defineGetter__ "offsetWidth",  -> 100
HTML.HTMLElement.prototype.__defineGetter__ "offsetHeight", -> 100
*/


HTML.HTMLAnchorElement.prototype._eventDefaults = {
  click: function(event) {
    var anchor;
    anchor = event.target;
    if (anchor.href) {
      return anchor.ownerDocument.parentWindow.location = anchor.href;
    }
  }
};

HTML.resourceLoader.load = function(element, href, callback) {
  var document, file, loaded, ownerImplementation, tagName, url, window;
  document = element.ownerDocument;
  window = document.parentWindow;
  ownerImplementation = document.implementation;
  tagName = element.tagName.toLowerCase();
  if (ownerImplementation.hasFeature('FetchExternalResources', tagName)) {
    switch (tagName) {
      case "iframe":
        if (/^javascript:/.test(href)) {
          return url = URL.parse(href);
        } else {
          url = this.resolve(element.window.parent.location, href);
          loaded = function(response, filename) {
            return callback(response.body, URL.parse(response.url).pathname);
          };
          return element.window.browser.resources.get(url, this.enqueue(element, loaded, url.pathname));
        }
        break;
      default:
        url = URL.parse(this.resolve(document, href));
        if (url.hostname) {
          loaded = function(response, filename) {
            return callback.call(this, response.body, URL.parse(response.url).pathname);
          };
          return window.browser.resources.get(url, this.enqueue(element, loaded, url.pathname));
        } else {
          loaded = function(data, filename) {
            return callback.call(this, data, filename);
          };
          file = this.resolve(document, url.pathname);
          return this.readFile(file, this.enqueue(element, loaded, file));
        }
    }
  }
};

HTML.Document.prototype._elementBuilders["iframe"] = function(doc, tag) {
  var iframe, parent;
  parent = doc.parentWindow;
  iframe = new HTML.HTMLIFrameElement(doc, tag);
  iframe.window = parent.browser.open({
    parent: parent
  });
  iframe.window.parent = parent;
  iframe._attributes.setNamedItem = function(node) {
    var url;
    HTML.NamedNodeMap.prototype.setNamedItem.call(iframe._attributes, node);
    if (node._nodeName === "src" && node._nodeValue) {
      url = URL.resolve(parent.location.href, URL.parse(node._nodeValue));
      return iframe.window.location.href = url;
    }
  };
  return iframe;
};

Object.defineProperty(HTML.CSSStyleDeclaration.prototype, "opacity", {
  get: function() {
    return this._opacity || "";
  },
  set: function(opacity) {
    if (opacity) {
      opacity = parseFloat(opacity);
      if (!isNaN(opacity)) {
        return this._opacity = opacity.toString();
      }
    } else {
      return delete this._opacity;
    }
  }
});

HTML.Node.prototype.__defineGetter__("textContent", function() {
  if (this.nodeType === HTML.Node.TEXT_NODE || this.nodeType === HTML.Node.COMMENT_NODE || this.nodeType === HTML.Node.ATTRIBUTE_NODE || this.nodeType === HTML.Node.CDATA_SECTION_NODE) {
    return this.nodeValue;
  } else if (this.nodeType === HTML.Node.ELEMENT_NODE || this.nodeType === HTML.Node.DOCUMENT_FRAGMENT_NODE) {
    return this.childNodes.filter(function(node) {
      return node.nodeType === HTML.Node.TEXT_NODE || node.nodeType === HTML.Node.ELEMENT_NODE || node.nodeType === HTML.Node.CDATA_SECTION_NODE;
    }).map(function(node) {
      return node.textContent;
    }).join("");
  } else {
    return null;
  }
});
